/**
	@class Global logger instance. <br />
*/
BookmarkTools.Logger = function(cfg){

	var LEVEL = {INFO : 'INFO', WARN : 'WARN', FATAL : 'FATAL', DEBUG : 'DEBUG'};
	var dest = null;

	this.init = function(){
		if(BookmarkTools.globals.logging){
			dest = Components.classes["@mozilla.org/consoleservice;1"].
			getService(Components.interfaces.nsIConsoleService);
		}
	}();
	
	var format = function(level, message, object, callee){
		var on = getObjectName(object);
		var fn = getFunctionName(object, callee);

		return level + ' - ' + on + '.' + fn + BookmarkTools.utils.StringUtils.TAB + ':' + BookmarkTools.utils.StringUtils.TAB + message + BookmarkTools.utils.StringUtils.LF;
	};
	
	var getFunctionName = function(object, callee){
		for(var i in object){
			var member = object[i];
			if(member == callee) return i;
		}
		return 'unknown';
	};
	
	var getObjectName = function(object){
		var c = object.constructor.toString();
		return c.substring(c.indexOf(' '), c.indexOf('('));
	};
	
	this.info = function(message, callee){
		if(BookmarkTools.globals.logging)
			dest.logStringMessage(format(LEVEL.INFO, message, cfg.object, callee));
	};
	
	this.warn = function(message, callee){
		if(BookmarkTools.globals.logging)
			dest.logStringMessage(format(LEVEL.WARN, message, cfg.object, callee));
	};
	
	this.fatal = function(message, callee){
		if(BookmarkTools.globals.logging)
			Components.utils.reportError(format(LEVEL.FATAL, message, cfg.object, callee));
	};
	
	this.debug = function(message, callee){
		if(BookmarkTools.globals.logging)
			dest.logStringMessage(format(LEVEL.DEBUG, message, cfg.object, callee));
	};

};
